DotIt = LibStub("AceAddon-3.0"):NewAddon("DotIT-0.1", "AceEvent-3.0", "AceHook-3.0", "AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):NewLocale("DotIt", "enUS", true)

local sb = LibStub:GetLibrary("SBar-0.1")
local cps = 0
DotIt.sb = sb
local newList, del, deepDel, deepCopy = sb:GetRecyclingFunctions()
DotIt.colorcache = {}
local expT = newList()



local function hideFixedText(uid, pos)
    local bars = sb:GetBars()
    if not bars then return end
    for _, bar in pairs(bars) do
        if bar.pos and bar.pos == pos then return end
    end
    sb:SetFixedText(nil, pos)
end
local function hideBar(info)
    local bars = sb:GetBars()
    if not bars then return end
    for _, bar in pairs(bars) do
        if bar.data and bar.data.dguid == info.dguid and bar.data.spellid == info.spellid and bar.data.typ == info.typ then
            local pos = bar.pos
            bar.start = nil
        end
    end
end

local function findFirstEmptyBar(init)
    local bars = sb:GetBars()
    if not bars then return init end
    for i = init, 10 do
        local flag = true
        for _, bar in pairs(bars) do 
            if bar.pos and bar.pos == i then
                flag = false
            end
        end
        if flag then return i end
    end
end

local function getBarPos(uid, typ)
    local init = 0
    if DotIt.db.profile.eshortbuffs then
        if typ == "Shortbuffs" then 
            return init 
        end
        init = init + 1
    end
    if DotIt.db.profile.ecooldowns then
        if typ == "Cooldowns" or typ ==  "ItemCooldowns" then 
            return init
        end
    end
    if DotIt.db.profile.einternalcooldowns then
        if typ == "InternalCooldowns" then 
            return init
        end
    end
    if DotIt.db.profile.ecooldowns or DotIt.db.profile.einternalcooldowns or DotIt.db.profile.eitemcooldowns then
        init = init + 1
    end
    
    if DotIt.db.profile.ebossmods then
        if typ == "Bossmods" then return init end
        init = init + 1
    end
    local bars = sb:GetBars()
    if not bars then return init end
    local maxpos = init
    local prv = init
    for _, bar in pairs(bars) do
        if bar.data then
            if bar.data.dguid == uid then
                return bar.pos
            end
        end
    end
    return findFirstEmptyBar(init)
end
function DotIt:GetBarPos(uid, typ)
    return getBarPos(uid, typ)
end
local function isBarActive(info)
    local bars = sb:GetBars()
    if not bars then return end
    for _, bar in pairs(bars) do
        if bar.data and bar.data.dguid == info.dguid and bar.data.spellid == info.spellid and bar.data.typ == info.typ then
            return true
        end
    end
    return false
end
local function setBarDur(info, dur)
    local bars = sb:GetBars()
    if bars then
        for _, bar in pairs(bars) do
            if bar.data and bar.data.dguid == info.dguid and bar.data.spellid == info.spellid then
                bar.dur = dur
                bar.start = 0
                return
            end
        end
    end
    local dur, appl, color, colorzero = DotIt:GetSpellInfo(info.typ, info.spellid)
    if not color then color = {r = 1, g = 1, b = 1, a = 1} end
    if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
    
    if not dur then return end
    if info and info.typ and not isBarActive(info) then
        sb:CreateBar(info, dur, 0, nil, select(3, GetSpellInfo(info.spellid)), getBarPos(info.dguid, info.typ), color, colorzero, DotIt.db.profile.bartexture)
    end
end

local function setBarColor(info, color, colorzero)
    local bars = sb:GetBars()
    if not bars then return end
    for _, bar in pairs(bars) do
        if bar.data and bar.data.dguid == info.dguid and bar.data.spellid == info.spellid then
            bar.color = deepCopy(color)
            bar.colorzero = deepCopy(colorzero)
            bar.tex:SetVertexColor(color.r, color.g, color.b, color.a)
            bar.texg:SetVertexColor(colorzero.r, colorzero.g, colorzero.b, colorzero.a)
        end
    end
end

function DotIt:StartItemCooldown(itemid, duration)
    if not DotIt:GetSpellInfo("ItemCooldowns", itemid) then return end
    local infocd = newList()
    infocd.typ = "ItemCooldowns"
    infocd.spellid = itemid
    infocd.dguid = UnitGUID("player")
    
    local dur, appl, color, colorzero = DotIt:GetSpellInfo(infocd.typ, itemid)
    if not color then color = {r = 1, g = 1, b = 1, a = 1} end
    if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
    
    
    if not isBarActive(infocd) and getBarPos(infocd.dguid, infocd.typ) then
        if dur == 0 then
            sb:CreateBar(deepCopy(infocd), duration, 0, nil, select(3, GetSpellInfo(itemid)), getBarPos(infocd.dguid, infocd.typ), color, colorzero, DotIt.db.profile.bartexture)
        else 
            sb:CreateBar(deepCopy(infocd), dur, 0, nil, select(3, GetSpellInfo(itemid)), getBarPos(infocd.dguid, infocd.typ), color, colorzero, DotIt.db.profile.bartexture)
        end
    end
    del(infocd)
end
local function schoolColor(spellschool)
    if spellschool == 1 then
        return deepCopy(DotIt.db.profile.barcolor.physical), deepCopy(DotIt.db.profile.barcolorzero.physical)
    elseif spellschool == 2 then
        return deepCopy(DotIt.db.profile.barcolor.holy), deepCopy(DotIt.db.profile.barcolorzero.holy)
    elseif spellschool == 4 then
        return deepCopy(DotIt.db.profile.barcolor.fire), deepCopy(DotIt.db.profile.barcolorzero.fire)
    elseif spellschool == 8 then
        return deepCopy(DotIt.db.profile.barcolor.nature), deepCopy(DotIt.db.profile.barcolorzero.nature)
    elseif spellschool == 16 then
        return deepCopy(DotIt.db.profile.barcolor.frost), deepCopy(DotIt.db.profile.barcolorzero.frost)
    elseif spellschool == 32 then
        return deepCopy(DotIt.db.profile.barcolor.shadow), deepCopy(DotIt.db.profile.barcolorzero.shadow)
    elseif spellschool == 64 then
        return deepCopy(DotIt.db.profile.barcolor.arcane), deepCopy(DotIt.db.profile.barcolorzero.arcane)
    end
end
function DotIt:getTyp(spellid)
    if DotIt:GetSpellInfo("Dots", spellid) then
        return "Dots"
    elseif DotIt:GetSpellInfo("Debuffs", spellid) then
       return "Debuffs"
    elseif DotIt:GetSpellInfo("CCs", spellid) then
        return "CCs"
    elseif DotIt:GetSpellInfo("Shortbuffs", spellid) then
        return "Shortbuffs"
    elseif DotIt:GetSpellInfo("InternalCooldowns", spellid) then
        return "InternalCooldowns"
    elseif DotIt:GetSpellInfo("SharedDebuffs", spellid) then
        return "SharedDebuffs"
    else return false end
end
local function createSpellInfo(dguid, spellid, typ)
    if not typ then return false end
    local infos = newList()
    infos.dguid = dguid
    infos.spellid = spellid
    infos.typ = typ
    return infos
end


function DotIt:SpellCooldownStart(spellid, duration)
    if not DotIt:GetSpellInfo("Cooldowns", spellid) then return end
    local infocd = newList()
    infocd.typ = "Cooldowns"
    infocd.spellid = spellid
    infocd.dguid = UnitGUID("player")
    
    local dur, appl, color, colorzero = DotIt:GetSpellInfo(infocd.typ, spellid)
    if not color then color = {r = 1, g = 1, b = 1, a = 1} end
    if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
    
    
    if not isBarActive(infocd) and getBarPos(infocd.dguid, infocd.typ) then
        if dur == 0 then
            sb:CreateBar(deepCopy(infocd), duration, 0, nil, select(3, GetSpellInfo(spellid)), getBarPos(infocd.dguid, infocd.typ), color, colorzero, DotIt.db.profile.bartexture)
        else 
            sb:CreateBar(deepCopy(infocd), dur, 0, nil, select(3, GetSpellInfo(spellid)), getBarPos(infocd.dguid, infocd.typ), color, colorzero, DotIt.db.profile.bartexture)
        end
    end
    del(infocd)
end
function DotIt:SpellCooldownEnd(spellid)
    if not DotIt:GetSpellInfo("Cooldowns", spellid) then return end
    local info = newList()
    info.typ = "Cooldowns"
    info.spellid = spellid
    info.dguid = UnitGUID("player")
    
    hideBar(info)
end
function DotIt:PLAYER_LOGIN()
    DotIt.sb:CreateScale(DotIt.db.profile.width, DotIt.db.profile.maxtime, DotIt.db.profile.steps,
                    DotIt.db.profile.maxneg, DotIt.db.profile.position,DotIt.db.profile.horizontal,
                    DotIt.db.profile.loflag, DotIt.db.profile.scaletexture, DotIt.db.profile.locked,
                    DotIt.db.profile.scale, DotIt.db.profile.height, DotIt.db.profile.fonts,
                    DotIt.db.profile.scaletext, DotIt.db.profile.amaxtimes, DotIt.db.profile.ehidescale,
                    DotIt.db.profile.eiconpos)
    self:SpellUpdate()
end
function DotIt:OnInitialize()
    self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEvent")
    self:RegisterEvent("UNIT_COMBO_POINTS", "SaveCombo")
    self:RegisterEvent("PLAYER_LOGIN")
end
local function removeDots()
    local init = 0
    if DotIt.db.profile.eshortbuffs then
        init = init + 1
    end
    if DotIt.db.profile.ecooldowns then
        init = init + 1
    end
    local bars = sb:GetBars()
    if not bars then return end
    for _, bar in pairs(bars) do
        if bar.pos and bar.pos >= init then
            bar.frame:Hide()
            bar.frame = nil
            local pos = bar.pos
            bar.pos = nil
            bar.data = nil
            deepDel(bar)
            bar = nil
        end
    end
end
local function addDots()
    
    for i = 1, 40 do
        if UnitDebuff("target", i) then
            local name, rank, _, application, _, _, expTime, ismine = UnitDebuff("target", i)
            if select(4, GetBuildInfo()) > 30000 then
                ismine = ismine == "player"
            end
            if name then
                if appl == 0 then appl = 1 end
                local link = GetSpellLink(name, rank)
                if link then
                    local spellid = string.match(link, "Hspell:(%d+)")
                    local info = createSpellInfo(UnitGUID("target"), spellid, DotIt:getTyp(spellid))
                    if info.typ == "SharedDebuffs" or ismine then 
                        if info then
                            spellid = tonumber(spellid)
                            local dur, appl, color, colorzero = DotIt:GetSpellInfo("Shortbuffs", spellid)
                            dur = expTime - GetTime()
                            
                            if not color then
                                color = deepCopy(DotIt.colorcache[spellid])
                                
                            end
                            if not color then
                                color = {r = 1, g = 1, b = 1, a = 1}
                            end
                            if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
                            if not appl or appl == 0 then appl = 1 end
                            if not application or application == 0 then application = 1 end
                            color.a = (application / appl) * (color.a or 1)

                            if (not isBarActive(info)) and getBarPos(info.dguid, info.typ) then
                                sb:CreateBar(deepCopy(info), dur, 0, nil, select(3, GetSpellInfo(spellid)), getBarPos(info.dguid, info.typ), color, colorzero, DotIt.db.profile.bartexture)
                            end
                        end
                    end
                end
            end
        end
    end
end
function DotIt:TargetChanged(msg, changer)
    if changer == "player" then
        removeDots()
        addDots()
    end
end
local function debuffCheck(cname, id)
    for i = 1, 40 do
        local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable  =  UnitDebuff("target", i)
        if select(4, GetBuildInfo()) > 30000 then
            isMine = isMine == "player"
        end
        if isMine and cname == name then
            return name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable
        end
        if DotIt:getTyp(id) == "SharedDebuffs" and cname == name then
            return name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable
        end
    end
end
function DotIt:CombatLogEvent(msg, timestamp, event, sguid, sname, sflags, dguid, dname, dflags, spellid, spellname, spellschool, auraType, application )
    -- buffs
    
    local info, dur, appl, color, colorzero
    if auraType == "BUFF" then
        if event == "SPELL_AURA_APPLIED" and (dguid == UnitGUID("player") or dguid == UnitGUID("pet")) then
            info = createSpellInfo(UnitGUID("player"), spellid, self:getTyp(spellid))
            if not info then return end
            dur, appl, color, colorzero = DotIt:GetSpellInfo("Shortbuffs", spellid)
            if not dur then return end
            if not tonumber(dur) then return end
            if not color then
                color, colorzero = schoolColor(spellschool)
            end
            if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
            if appl then
                color.a = (1/appl) * (color.a or 1)
            end

            if not isBarActive(info) and getBarPos(info.dguid, info.typ) then
                sb:CreateBar(deepCopy(info), tonumber(dur), 0, nil, select(3, GetSpellInfo(spellid)), getBarPos(info.dguid, info.typ), color, colorzero, self.db.profile.bartexture)
            end
            deepDel(info)
            info = nil
            -- internal cooldowns
            info = createSpellInfo(UnitGUID("player"), spellid, "InternalCooldowns")
            dur, appl, color, colorzero = DotIt:GetSpellInfo("InternalCooldowns", spellid)
            if not dur then return end
            if not tonumber(dur) then return end
            if not color then
                color, colorzero = schoolColor(spellschool)
            end
            if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
            if appl then
                color.a = (1/appl) * (color.a or 1)
            end
            if not isBarActive(info) and getBarPos(info.dguid, info.typ) then
                sb:CreateBar(deepCopy(info), dur, 0, nil, select(3, GetSpellInfo(spellid)), getBarPos(info.dguid, info.typ), color, colorzero, self.db.profile.bartexture)
            end
            -- ic end
        elseif event == "SPELL_AURA_REMOVED" and (dguid == UnitGUID("player") or dguid == UnitGUID("pet")) then
            info = createSpellInfo(UnitGUID("player"), spellid, self:getTyp(spellid))
            if not info then return end
            if not (info.typ == "InternalCooldowns") then
                hideBar(info)
            end
        elseif event == "SPELL_AURA_APPLIED_DOSE" and (dguid == UnitGUID("player") or dguid == UnitGUID("pet")) then
            info = createSpellInfo(UnitGUID("player"), spellid, self:getTyp(spellid))
            if not info then return end
            dur, appl, color, colorzero = self:GetSpellInfo("Shortbuffs", spellid)
            if not color then
                color, colorzero = schoolColor(spellschool)
            end
            color.a = (application / appl) * (color.a or 1)
            if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
            setBarDur(deepCopy(info), self:GetSpellInfo("Shortbuffs", spellid))
            setBarColor(info, color, colorzero)
        elseif event == "SPELL_AURA_REFRESH" and (dguid == UnitGUID("player") or dguid == UnitGUID("pet")) then
            info = createSpellInfo(UnitGUID("player"), spellid, self:getTyp(spellid))
            if not info then return end
            dur, appl, color, colorzero = self:GetSpellInfo("Shortbuffs", spellid)
            setBarDur(deepCopy(info), dur)
        end
    elseif auraType == "DEBUFF" then
    -- debuffs
        if event == "SPELL_AURA_APPLIED" then
            if DotIt:GetSpellInfo("SharedDebuffs", spellid) or (sguid == UnitGUID("player")) then
                if (self.db.profile.owndots and dguid == UnitGUID("target")) or (not self.db.profile.owndots) then
                    info = createSpellInfo(dguid, spellid, self:getTyp(spellid))
                    if not info then return end
                    expT[spellid..dguid] = select(7, debuffCheck(spellname, spellid))
                    dur, appl, color, colorzero = self:GetSpellInfo(info.typ, spellid)
                    if not color then
                        color, colorzero = schoolColor(spellschool)
                    end
                    
                    if appl then
                        color.a = (1/appl) * (color.a or 1)
                    end
                    
                    if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
                    if not isBarActive(info) and getBarPos(info.dguid, info.typ) then
                        sb:CreateBar(deepCopy(info), dur, 0, nil, select(3, GetSpellInfo(spellid)), getBarPos(info.dguid, info.typ), color, colorzero, self.db.profile.bartexture)
                        if not self.db.profile.owndots then
                            if not self.db.profile.ehidetext then
                                sb:SetFixedText(dname, getBarPos(info.dguid, info.typ))
                            end
                        end
                        DotIt.colorcache[spellid] = deepCopy(color)
                    end
                end
            end
        -- this event does not provide sguid! returns 0
        elseif event == "SPELL_AURA_REFRESH" and dguid == UnitGUID("target") then
            ------------------------------------------
            --
            -- temorary fix! (because sguid is alway 0)
            --
            ------------------------------------------
            local expirationTime = select(7, debuffCheck(spellname, spellid))
            if not expirationTime then return end
            if not expT[spellid..dguid] then return end
            if expT[spellid..dguid] == expirationTime then return end
            expT[spellid..dguid] = expirationTime
            ------------------------------------------
            --
            -- temorary fix end!
            --
            ------------------------------------------
            info = createSpellInfo(dguid, spellid, self:getTyp(spellid))
            if not info then return end
            setBarDur(deepCopy(info), self:GetSpellInfo(info.typ, spellid))
        -- this event does not provide sguid! returns 0
        elseif event == "SPELL_AURA_APPLIED_DOSE" and dguid == UnitGUID("target") then
            ------------------------------------------
            --
            -- temorary fix! (because sguid is alway 0)
            --
            ------------------------------------------
            local expirationTime = select(7, debuffCheck(spellname, spellid))
            if not expirationTime then return end
            if not expT[spellid..dguid] then return end
            if expT[spellid..dguid] == expirationTime then return end
            expT[spellid..dguid] = expirationTime
            ------------------------------------------
            --
            -- temorary fix end!
            --
            ------------------------------------------
            info = createSpellInfo(dguid, spellid, self:getTyp(spellid))
            if not info then return end
            dur, appl, color, colorzero = self:GetSpellInfo(info.typ, spellid)
            if not color then
                color, colorzero = schoolColor(spellschool)
            end
            if appl then
                color.a = (application/appl) * (color.a or 1)
            end
            setBarDur(deepCopy(info), self:GetSpellInfo(info.typ, spellid))
            setBarColor(info, color, colorzero)
        elseif event == "SPELL_AURA_REMOVED" and (sguid == UnitGUID("player") or DotIt:getTyp(spellid) == "SharedDebuffs") then
            info = createSpellInfo(dguid, spellid, self:getTyp(spellid))
            if not info then return end
            expT[spellid..dguid] = nil
            hideBar(info)
        end
    end
    if info then
        deepDel(info)
    end
end
function DotIt:SaveCombo(msg, unit)
    if GetComboPoints("player") ~= 0 then
        cps = GetComboPoints("player")
    end
end
function DotIt:GetComboPoints()
    return cps
end
function DotIt:checkGlyph(name)
	for i = 1, 6 do
		local glyph = select(3, GetGlyphSocketInfo(i))
		if glyph == name then
			return true
		else
			return false
		end
	end
end
function DotIt:scanItem(id)
	for i = 0, 18 do
		if string.find(GetInventoryItemLink("player", i), id) then return true end
	end
	return false
end